## papilo 2.4.1%2Bds

=== debian/changelog ===
papilo (2.4.1+ds-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:05:57 +0200

papilo (2.4.1+ds-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:55:33 +0200

papilo (2.4.1+ds-1) unstable; urgency=medium

  * Fix FTBFS with fmtlib 10.1.1
  * New upstream version 2.4.1+ds
  * Update patches
    - Drop 0001-Add-BUILD_TESTING-support.patch (obsolete)
  * Update d/copyright
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Mon, 10 Feb 2025 11:01:56 +0100

papilo (2.3.0+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1083119)

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Oct 2024 01:33:09 +0200

## papilo 2.4.1+ds

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.11.0)

set(PAPILO_VERSION_MAJOR 2)
set(PAPILO_VERSION_MINOR 4)
set(PAPILO_VERSION_PATCH 1)
set(PAPILO_API_VERSION 3)

project(papilo VERSION ${PAPILO_VERSION_MAJOR}.${PAPILO_VERSION_MINOR}.${PAPILO_VERSION_PATCH}.0)

set(BOOST_MIN_VERSION 1.65)
set(CMAKE_CXX_STANDARD 14)
set(CXX_STANDARD_REQUIRED ON)

# Each directory used during linking is appended to the rpath of installed libraries.
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# set(CMAKE_CXX_EXTENSIONS OFF) # use -std=c++... instead of -std=gnu++...
# required for gcc if set(CMAKE_CXX_EXTENSIONS OFF) is used
# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fext-numeric-literals")

# if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
# endif()
if(MSVC)
   add_compile_options(/permissive)
endif()

# Sets installation directories according to GNU coding standards.
include(GNUInstallDirs)
#add_definitions ("-Wall")

# Location for storing CMake files.
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules/)

# Functions without PAPILOLIB_EXPORT will not be accessible from outside.
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# Even static libs have position-independent code by default, and can be linked into shared libs.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Disable fused floating point contraction to enhance reproducibility across compilers and
# architectures.
if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
   add_compile_options(/fp:precise)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Intel")
   add_compile_options(-fp-model=precise)
elseif((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
   add_compile_options(-ffp-contract=off)
endif()

option(GMP "should gmp be linked" ON)
option(QUADMATH "should quadmath library be used" ON)
if(MSVC)
   option(LUSOL "should LUSOL package be enabled" OFF)
else()
   option(LUSOL "should LUSOL package be enabled" ON)
endif()

option(TBB "should TBB be linked if found" ON)
option(TBB_DOWNLOAD "should TBB be downloaded" OFF)
option(INSTALL_TBB "should the TBB library be installed" OFF)

option(SOPLEX "should SoPlex LP solver be linked if found" ON)
option(SCIP "should SCIP solver be linked if found" ON)
option(HIGHS "should HiGHS LP solver be linked" OFF)
option(GLOP "should ortools solver be linked" OFF)
option(GUROBI "should gurobi solver be linked" OFF)

option(BUILD_TESTING "should tests be enabled and built" ON)

# Make 'Release' the default build type.
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release)
endif()

message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

# Search for Boost: headers are required and the other components are needed for the binaries.
find_package(Boost ${BOOST_MIN_VERSION} REQUIRED OPTIONAL_COMPONENTS iostreams program_options serialization)
if(Boost_IOSTREAMS_FOUND)
   set(PAPILO_HAVE_BOOST_IOSTREAMS 1)
else()
   set(PAPILO_HAVE_BOOST_IOSTREAMS 0)
endif()
if(Boost_PROGRAM_OPTIONS_FOUND)
   set(PAPILO_COMMAND_LINE_AVAILABLE 1)
else()
   set(PAPILO_COMMAND_LINE_AVAILABLE 0)
endif()
if(Boost_SERIALIZATION_FOUND)
   set(PAPILO_SERIALIZATION_AVAILABLE 1)
endif()
if(NOT Boost_IOSTREAMS_FOUND OR NOT Boost_PROGRAM_OPTIONS_FOUND OR NOT Boost_SERIALIZATION_FOUND)
   message("WARNING: Boost iostreams, program_options or serialization not found. PaPILO can only be used as a library!")
endif()

# Search for GMP.
if(GMP)
   find_package(GMP)
endif()
if(GMP_FOUND)
   set(PAPILO_HAVE_GMP 1)
   set(GMP_VERSION "${GMP_VERSION}")
else()
   set(PAPILO_HAVE_GMP 0)
   set(GMP_INCLUDE_DIRS "")
   set(GMP_LIBRARIES "")
endif()

# Search for Quadmath.
if(QUADMATH)
   find_package(Quadmath)
endif()
if(Quadmath_FOUND)
   set(PAPILO_HAVE_FLOAT128 1)
else()
   set(PAPILO_HAVE_FLOAT128 0)
   set(Quadmath_INCLUDE_DIRS "")
endif()

# Search for Gurobi.
if(GUROBI)
   find_package(GUROBI REQUIRED)
endif()

# Search for GLOP.
if(GLOP)
   find_package(GLOP REQUIRED)
endif()

# Search for git.
find_program(GIT git)
if((GIT) AND (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git))
   # If git is available and this is a repository, we query the git hash.
   execute_process(
      COMMAND ${GIT} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      OUTPUT_VARIABLE PAPILO_GITHASH OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
   # Otherwise we extract the githash in case was defined in papilo/Config.hpp.
   file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/src/papilo/Config.hpp githash_define REGEX "define PAPILO_GITHASH .*")
   if(githash_define)
      string(REGEX MATCH "\\\"(.*)\\\"" _matched ${githash_define})
      if(_matched)
         set(PAPILO_GITHASH ${CMAKE_MATCH_1})
      endif()
   endif()
endif()

# Output the githash.
if(PAPILO_GITHASH)
   message(STATUS "Git hash: ${PAPILO_GITHASH}")
   set(PAPILO_GITHASH_AVAILABLE 1)
else()
   set(PAPILO_GITHASH_AVAILABLE 0)
endif()

# Target `papilo` is an interface with all the dependencies.
add_library(papilo INTERFACE)
if(ROUNDINGSAT_DIR)
   set(ROUNDINGSAT_INCLUDE_DIRS ${ROUNDINGSAT_DIR}/src/)
endif()
target_include_directories(papilo INTERFACE
   $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
   $<INSTALL_INTERFACE:include>
   ${GMP_INCLUDE_DIRS}
   ${Quadmath_INCLUDE_DIRS}
   ${ROUNDINGSAT_INCLUDE_DIRS})

# Add the Boost dependencies that were found.
if(PAPILO_HAVE_BOOST_IOSTREAMS)
   target_link_libraries(papilo INTERFACE Boost::iostreams)
endif()
if(PAPILO_COMMAND_LINE_AVAILABLE)
   target_link_libraries(papilo INTERFACE Boost::program_options)
endif()
if(PAPILO_SERIALIZATION_AVAILABLE)
   target_link_libraries(papilo INTERFACE Boost::serialization)
endif()
if(Quadmath_FOUND)
   target_link_libraries(papilo INTERFACE Quadmath::quadmath)
endif()

# Search for TBB.
if(TBB)
   set(PAPILO_TBB on)
   # On windows we do not build TBB.
   if(WIN32)
      find_package(TBB 2018 COMPONENTS tbb tbbmalloc REQUIRED)
   else()
      if(TBB_DOWNLOAD)
         # Utilities to automatically download and build missing dependencies.
         include(cmake/Dependencies.cmake)
         find_or_download_package(
            NAME TBB
            VERSION 2018
            URL https://github.com/oneapi-src/oneTBB/archive/refs/tags/v2021.13.0.tar.gz
            COMPONENTS tbb tbbmalloc
            URL_HASH SHA256=3ad5dd08954b39d113dc5b3f8a8dc6dc1fd5250032b7c491eb07aed5c94133e1
            CONFIGURE_ARGS -DTBB_TEST=OFF -DTBB_EXAMPLES=OFF -DTBB4PY_BUILD=OFF)
      else()
         # Otherwise we try to find TBB.
         find_package(TBB 2018 COMPONENTS tbb tbbmalloc)
      endif()
      if(NOT TBB_FOUND)
         message(FATAL_ERROR "TBB was not found. Please specify its location (-DTBB_DIR=...), enable auto-download of TBB (-DTBB_DOWNLOAD=on) or disable TBB (-DTBB=off).")
      else()
         message(STATUS "Found TBB: ${TBB_DIR}") # TODO: Extract and print version information.
      endif()
   endif()

   # Add this to the `papilo` target.
   target_link_libraries(papilo INTERFACE TBB::tbb Threads::Threads $<$<PLATFORM_ID:Linux>:rt>)
else()
   set(PAPILO_TBB off)
   message(WARNING "Disabling TBB results in a dramatically degradation in the performance of PaPILO!")
endif()

# Search for Threads.
find_package(Threads REQUIRED)

# TODO: Fix FindGMP.cmake and FindGLOP to create targets instead of variables.
target_link_libraries(papilo
   INTERFACE ${GMP_LIBRARIES} ${GLOP_LIBRARIES})

# Determines whether -latomic must be added.
# TODO: Fix cmake/StdAtomic.cmake to create a target that can then be added to `papilo`.
include(cmake/StdAtomic.cmake)

# For `write_basic_package_version_file` function.
include(CMakePackageConfigHelpers)

write_basic_package_version_file(
   ${CMAKE_BINARY_DIR}/papilo-config-version.cmake
   VERSION ${PAPILO_VERSION_MAJOR}.${PAPILO_VERSION_MINOR}.${PAPILO_VERSION_PATCH}
   COMPATIBILITY SameMajorVersion
)

# Specific compilation flags.
if(MSVC)
   target_compile_definitions(papilo INTERFACE BOOST_ALL_NO_LIB)
   target_compile_options(papilo INTERFACE /bigobj)
   target_compile_options(papilo INTERFACE ${TBB_CXX_STD_FLAG})
else()
   #TODO: configure warning level https://stackoverflow.com/questions/2368811/how-to-set-warning-level-in-cmake
   target_compile_options(papilo INTERFACE ${TBB_CXX_STD_FLAG} -Wno-shadow -Wall)
endif()

# Search for BLAS and build clusol.
if(LUSOL)
   include(CheckLanguage)
   check_language(Fortran)
   find_package(BLAS)
endif()
if(CMAKE_Fortran_COMPILER AND BLAS_FOUND)
   enable_language(Fortran)

   add_library(clusol STATIC
      src/papilo/external/lusol/src/lusol6b.f
      src/papilo/external/lusol/src/lusol7b.f
      src/papilo/external/lusol/src/lusol8b.f
      src/papilo/external/lusol/src/lusol_util.f
      src/papilo/external/lusol/src/lusol.f90
      src/papilo/external/lusol/src/clusol.c
      src/papilo/external/lusol/src/lusol_precision.f90)
   set_property(TARGET clusol PROPERTY POSITION_INDEPENDENT_CODE ON)
   target_include_directories(clusol PRIVATE src/papilo/external/lusol)
   target_link_libraries(clusol ${BLAS_LIBRARIES})
   target_link_libraries(papilo INTERFACE clusol)
   set(PAPILO_HAVE_LUSOL 1)
   set(CLUSOL_TARGET clusol)
else()
   set(PAPILO_HAVE_LUSOL 0)
   set(CLUSOL_TARGET "")
   message(STATUS "LUSOL is not built")
endif()

# For `check_cxx_source_compiles` function.
include(CheckCXXSourceCompiles)
# For `check_cxx_compiler_flag` function.
include(CheckCXXCompilerFlag)

if(NOT MSVC)
   # Except for Windows we set the standard to C++14.
   check_cxx_compiler_flag(-std=c++14 HAVE_FLAG_STD_CXX14)
   if(HAVE_FLAG_STD_CXX14)
      set(CMAKE_REQUIRED_FLAGS "-std=c++14")
   else()
      check_cxx_compiler_flag(-std=c++1y HAVE_FLAG_STD_CXX1Y)
      if(HAVE_FLAG_STD_CXX1Y)
         set(CMAKE_REQUIRED_FLAGS "-std=c++1y")
      endif()
   endif()
endif()

# Includes for `check_cxx_source_compiles` call.
set(CMAKE_REQUIRED_INCLUDES ${PROJECT_SOURCE_DIR}/src/papilo/external)
check_cxx_source_compiles(
   "#include \"ska/bytell_hash_map.hpp\"
   int main() { ska::bytell_hash_map<int,int> hashmap; (void)hashmap; return 0; }"
   PAPILO_BYTELL_HASHMAP_WORKS )

if(PAPILO_BYTELL_HASHMAP_WORKS)
   set(PAPILO_USE_STANDARD_HASHMAP 0)
else()
   set(PAPILO_USE_STANDARD_HASHMAP 1)
endif()

# Create target `papilo-core` which is the static library.
add_library(papilo-core STATIC
   src/papilo/core/VariableDomains.cpp
   src/papilo/core/SparseStorage.cpp
   src/papilo/core/ConstraintMatrix.cpp
   src/papilo/core/ProblemUpdate.cpp
   src/papilo/core/Presolve.cpp
   src/papilo/core/postsolve/PostsolveStorage.cpp
   src/papilo/core/postsolve/Postsolve.cpp
   src/papilo/core/ProbingView.cpp
   src/papilo/presolvers/CoefficientStrengthening.cpp
   src/papilo/presolvers/ConstraintPropagation.cpp
   src/papilo/presolvers/DominatedCols.cpp
   src/papilo/presolvers/DualFix.cpp
   src/papilo/presolvers/DualInfer.cpp
   src/papilo/presolvers/FixContinuous.cpp
   src/papilo/presolvers/FreeVarSubstitution.cpp
   src/papilo/presolvers/ImplIntDetection.cpp
   src/papilo/presolvers/ParallelColDetection.cpp
   src/papilo/presolvers/ParallelRowDetection.cpp
   src/papilo/presolvers/Probing.cpp
   src/papilo/presolvers/SimpleProbing.cpp
   src/papilo/presolvers/SimpleSubstitution.cpp
   src/papilo/presolvers/SingletonCols.cpp
   src/papilo/presolvers/SingletonStuffing.cpp
   src/papilo/presolvers/Sparsify.cpp
   src/papilo/presolvers/SimplifyInequalities.cpp
   ${roundingsat_source_files}
  )

#
# interface function for setting common library properties
#
# TODO: Simplify with a generator expression.
function(setLibProperties targetname outputname)
    set_target_properties(${targetname} PROPERTIES
        OUTPUT_NAME ${outputname}
        MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endfunction(setLibProperties)
if(MSVC)
    setLibProperties(papilo-core "libpapilo-core")
else()
   setLibProperties(papilo-core "papilo-core")
endif()


# Add dependency-target `papilo` to static library-target `papilo-core`.

=== binaries/CMakeLists.txt ===
# Note: This file is included from papilo/CMakeLists.txt and scipoptsuite/CMakeLists.
#       All variables it relies on must be supplied by both these files.

include(GenerateExportHeader)

if(SCIP)
   find_package(SCIP)
endif()
if(SCIP_FOUND)
   message(STATUS "Found SCIP: ${SCIP_INCLUDE_DIRS}")
   set(PAPILO_HAVE_SCIP 1)
else()
   message(STATUS "Finding SCIP - not found")
   set(PAPILO_HAVE_SCIP 0)
endif()

if(GUROBI)
   find_package(GUROBI REQUIRED)
endif()
if(GUROBI_FOUND)
   message(STATUS "Found GUROBI: ${GUROBI_INCLUDE_DIRS}")
   set(PAPILO_HAVE_GUROBI 1)
   include_directories(${GUROBI_INCLUDE_DIRS})
else()
   message(STATUS "Finding GUROBI - not found")
   set(PAPILO_HAVE_GUROBI 0)
endif()

if(GLOP)
   find_package(GLOP REQUIRED)
endif()
if(GLOP_FOUND)
   message(STATUS "Found GLOP: ${GLOP_INCLUDE_DIRS}")
   set(PAPILO_HAVE_GLOP 1)
   include_directories(${GLOP_INCLUDE_DIRS})
else()
   message(STATUS "Finding GLOP - not found")
   set(PAPILO_HAVE_GLOP 0)
endif()


if(SOPLEX)
   find_package(SOPLEX)
endif()
if(SOPLEX_FOUND)
   message(STATUS "Found SOPLEX: ${SOPLEX_INCLUDE_DIRS}")
   set(PAPILO_HAVE_SOPLEX 1)
else()
   message(STATUS "Finding SOPLEX - not found")
   set(PAPILO_HAVE_SOPLEX 0)
endif()

if(HIGHS)
   find_package(HIGHS CONFIG REQUIRED)
endif()
if(HIGHS_FOUND)
   message(STATUS "Found HIGHS: ${HIGHS_INCLUDE_DIRS}")
   set(PAPILO_HAVE_HIGHS 1)
else()
   message(STATUS "Finding HIGHS - not found")
   set(PAPILO_HAVE_HIGHS 0)
endif()

if(ROUNDINGSAT_DIR)
   set(PAPILO_HAVE_ROUNDINGSAT 1)
endif()
set(CMAKE_CXX_STANDARD 14)
if(ROUNDINGSAT_DIR)
   message(STATUS "Found ROUNDINGSAT: ${ROUNDINGSAT_DIR}")
   set(CMAKE_CXX_STANDARD 17)
else()
   message(STATUS "Finding ROUNDINGSAT - not found")
   set(PAPILO_HAVE_ROUNDINGSAT 0)
endif()

# Enable the Fortran language support when the clusol target is included.
# Even though this was done in the papilo CMake to create the target, it must be
# done here as well, since the language support is restricted to the calling directory
# and subdirectories, and since the papilo/binaries CMake can be called from a
# CMake which doesn't have Fortran language enabled, Fortran might not be enabled here yet.
if(TARGET clusol)
   include(CheckLanguage)
   check_language(Fortran)
   enable_language(Fortran)
endif()

# Search again since we cannot rely on papilo/CMakeLists.txt having searched for Boost already.
find_package(Boost ${BOOST_MIN_VERSION} OPTIONAL_COMPONENTS iostreams program_options serialization)

include_directories(${SCIP_INCLUDE_DIRS} ${SOPLEX_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})

if(Boost_IOSTREAMS_FOUND)
   set(CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
   set(CMAKE_REQUIRED_LIBRARIES ${Boost_LIBRARIES})
   check_cxx_source_compiles(
      "#include <boost/iostreams/filter/gzip.hpp>
       int main() { auto decomp = boost::iostreams::gzip_decompressor(); (void)decomp; return 0; }"
      PAPILO_USE_BOOST_IOSTREAMS_WITH_ZLIB )
   check_cxx_source_compiles(
      "#include <boost/iostreams/filter/bzip2.hpp>
       int main() { auto decomp = boost::iostreams::bzip2_decompressor(); (void)decomp; return 0; }"
      PAPILO_USE_BOOST_IOSTREAMS_WITH_BZIP2 )
   unset(CMAKE_REQUIRED_INCLUDES)
   unset(CMAKE_REQUIRED_LIBRARIES)
endif()

if(Boost_IOSTREAMS_FOUND AND Boost_SERIALIZATION_FOUND AND Boost_PROGRAM_OPTIONS_FOUND)
#   add_executable(duplicates  ${CMAKE_CURRENT_LIST_DIR}/../src/duplicates.cpp)
#   set_target_properties(duplicates PROPERTIES OUTPUT_NAME duplicates RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin" )
#   target_link_libraries(duplicates papilo-core ${Boost_LIBRARIES})
#   target_compile_definitions(duplicates PRIVATE PAPILO_USE_EXTERN_TEMPLATES PAPILO_MPS_WRITER)

   if(ROUNDINGSAT_DIR)
      set(
         roundingsat_source_files
         ${ROUNDINGSAT_DIR}/src/Constr.cpp
         ${ROUNDINGSAT_DIR}/src/ConstrExp.cpp
         ${ROUNDINGSAT_DIR}/src/ConstrSimple.cpp
         ${ROUNDINGSAT_DIR}/src/LpSolver.cpp
         ${ROUNDINGSAT_DIR}/src/Solver.cpp
         ${ROUNDINGSAT_DIR}/src/parsing.cpp
         ${ROUNDINGSAT_DIR}/src/quit.cpp
         ${ROUNDINGSAT_DIR}/src/run.cpp
         ${ROUNDINGSAT_DIR}/src/SolverStructs.cpp
         ${ROUNDINGSAT_DIR}/src/used_licenses/gpl_3_0.cpp
         ${ROUNDINGSAT_DIR}/src/used_licenses/zib_academic.cpp
         ${ROUNDINGSAT_DIR}/src/used_licenses/roundingsat.cpp
         ${ROUNDINGSAT_DIR}/src/used_licenses/MIT.cpp
         ${ROUNDINGSAT_DIR}/src/used_licenses/licenses.cpp
         ${ROUNDINGSAT_DIR}/src/used_licenses/boost.cpp
         ${ROUNDINGSAT_DIR}/src/used_licenses/lgpl_3_0.cpp
   )
   endif()
   add_executable(papilo-executable ${CMAKE_CURRENT_LIST_DIR}/../src/papilo.cpp ${roundingsat_source_files})

   if(PAPILO_HAVE_ROUNDINGSAT)
      list(APPEND linked_solvers "Roundingsat")
      set(PAPILO_HAVE_ROUNDINGSAT 1 PARENT_SCOPE)
      target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_ROUNDINGSAT)
   endif()
   if(PAPILO_HAVE_SCIP)
      list(APPEND linked_solvers "SCIP")
      set(PAPILO_HAVE_SCIP 1 PARENT_SCOPE)
      target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_SCIP)
   endif()
   if(PAPILO_HAVE_GUROBI)
      list(APPEND linked_solvers "GUROBI")
      set(PAPILO_HAVE_GUROBI 1 PARENT_SCOPE)
      target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_GUROBI)
   endif()
   if(PAPILO_HAVE_GLOP)
      list(APPEND linked_solvers "GLOP")
      set(PAPILO_HAVE_GLOP 1 PARENT_SCOPE)
      target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_GLOP)
   endif()
   if(PAPILO_HAVE_SOPLEX)
      list(APPEND linked_solvers "SoPlex")
      set(PAPILO_HAVE_SOPLEX 1 PARENT_SCOPE)
      target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_SOPLEX)
   endif()
   if(PAPILO_HAVE_HIGHS)
      list(APPEND linked_solvers "HiGHS")
      set(PAPILO_HAVE_HIGHS 1 PARENT_SCOPE)
      find_package(OpenMP)
      target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_HIGHS)
      target_link_libraries(papilo-executable highs::highs)
   endif()
   if(linked_solvers)
      message(STATUS "Linking solvers: ${linked_solvers}")
   else()
      message(STATUS "No solvers linked")
   endif()
   set_target_properties(papilo-executable PROPERTIES OUTPUT_NAME papilo RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin" )
   target_link_libraries(papilo-executable papilo-core ${SOPLEX_LIBRARIES} ${SCIP_LIBRARIES} Boost::boost Boost::iostreams Boost::program_options Boost::serialization ${GUROBI_LIBRARIES})
   if(INSTALL_TBB)
      set_target_properties(papilo-executable PROPERTIES INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/cmake/papilo/_deps/local/lib/)
   endif()
   target_compile_definitions(papilo-executable PRIVATE PAPILO_USE_EXTERN_TEMPLATES PAPILO_MPS_WRITER)
   install(TARGETS papilo-executable ARCHIVE DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

#   add_executable(convMPS EXCLUDE_FROM_ALL ${CMAKE_CURRENT_LIST_DIR}/../src/convMPS.cpp)
#   set_target_properties(convMPS PROPERTIES OUTPUT_NAME convMPS RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
#   target_link_libraries(convMPS papilo-core ${Boost_LIBRARIES})
else()
   message(WARNING "Executable of PaPILO is not built because Boost iostreams, serialization or program options is missing")
endif()

#TODO: consider case Gurobi and SCIP are build
if(PAPILO_HAVE_SCIP AND PAPILO_HAVE_SOPLEX)
   add_library(papilolib SHARED ${CMAKE_CURRENT_LIST_DIR}/../src/papilolib.cpp)
   set_target_properties(papilolib PROPERTIES OUTPUT_NAME papilo LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
   target_include_directories(papilolib INTERFACE
      $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
   target_link_libraries(papilolib papilo ${SOPLEX_PIC_LIBRARIES} ${SCIP_LIBRARIES})
   if( Boost_IOSTREAMS_FOUND )
      target_compile_definitions(papilolib PRIVATE PAPILO_MPS_WRITER)
      target_link_libraries(papilolib Boost::boost Boost::iostreams)
   endif()
   generate_export_header(papilolib)
endif()

=== test/CMakeLists.txt ===
find_package(Boost REQUIRED OPTIONAL_COMPONENTS serialization program_options iostreams)

if (TARGET papilolib)
    set(PAPILOLIB_TESTS
            "papilolib"
            "papilolib-no-rows"
            )
    set(PAPILOLIB_TEST_FILE PapiloLib.cpp)
    set(PAPILOLIB_TARGET papilolib)
else ()
    set(PAPILOLIB_TESTS "")
    set(PAPILOLIB_TEST_FILE "")
    set(PAPILOLIB_TARGET "")
endif ()

if (Boost_IOSTREAMS_FOUND AND Boost_SERIALIZATION_FOUND AND Boost_PROGRAM_OPTIONS_FOUND)
#    configure_file(resources/dual_fix_neg_inf.postsolve resources/dual_fix_neg_inf.postsolve COPYONLY)
#    configure_file(resources/dual_fix_pos_inf.postsolve resources/dual_fix_pos_inf.postsolve COPYONLY)
    configure_file(instances/dual_fix_neg_inf.mps resources/dual_fix_neg_inf.mps COPYONLY)
    set(BOOST_REQUIRED_TESTS
#            "finding-the-right-value-in-postsolve-for-a-column-fixed-pos-inf"
#            "finding-the-right-value-in-postsolve-for-a-column-fixed-neg-inf"
            "mps-parser-loading-simple-problem"
            )
    set(BOOST_REQUIRED_TEST_FILES
#            papilo/core/PostsolveTest.cpp
            papilo/io/MpsParserTest.cpp
            )
else ()
    set(BOOST_REQUIRED_TESTS "")
    set(BOOST_REQUIRED_TEST_FILES)
endif ()

add_executable(unit_test TestMain.cpp

        papilo/core/MatrixBufferTest.cpp
        papilo/core/SparseStorageTest.cpp
        papilo/core/PresolveTest.cpp
        papilo/core/ProblemUpdateTest.cpp
        papilo/misc/VectorUtilsTest.cpp

        papilo/presolve/CoefficientStrengtheningTest.cpp
        papilo/presolve/ConstraintPropagationTest.cpp
        papilo/presolve/DualFixTest.cpp
        papilo/presolve/DominatedColsTest.cpp
        papilo/presolve/FixContinuousTest.cpp
        papilo/presolve/FreeVarSubstitutionTest.cpp
        papilo/presolve/ImplIntDetectionTest.cpp
        papilo/presolve/ParallelRowDetectionTest.cpp
        papilo/presolve/ParallelColDetectionTest.cpp
        papilo/presolve/ProbingTest.cpp
        papilo/presolve/SingletonColsTest.cpp
        papilo/presolve/SingletonStuffingTest.cpp
        papilo/presolve/SimpleProbingTest.cpp
        papilo/presolve/SimpleSubstitutionTest.cpp
        papilo/presolve/SimplifyInequalitiesTest.cpp
        papilo/presolve/SparsifyTest.cpp

        ${BOOST_REQUIRED_TEST_FILES}
        ${PAPILOLIB_TEST_FILE})

target_link_libraries(unit_test papilo ${PAPILOLIB_TARGET} ${Boost_LIBRARIES})
if(${CMAKE_SYSTEM_NAME} STREQUAL "Android")
    target_link_libraries(unit_test log)
endif()

set(unit_tests

        "matrix-buffer"
        "vector-comparisons"
        "matrix-comparisons"

        "replacing-variables-is-postponed-by-flag"
        "happy-path-replace-variable"
        "happy-path-substitute-matrix-coefficient-into-objective"
        "happy-path-aggregate-free-column"
        "presolve-activity-is-updated-correctly-huge-values"

        #ProblemUpdate
        "trivial-presolve-singleton-row"
        "trivial-presolve-singleton-row-pt-2"

        "problem-comparisons"

        #Coefficient-strengthening
        "happy-path-coefficient-strengthening"

        #ConstraintPropagation
        "constraint-propagation-happy-path"
        "constraint-propagation-no-tightening-for-lp"

        #DomCol
        "domcol-happy-path"
        "domcol-parallel-columns"
        "domcol-multiple-parallel-cols-generate_redundant-reductions"
        "domcol-multiple-columns"

        #DualFix
        "dual-fix-happy-path"
        "dual-fix-trivial-column-presolve-finds-reduction"
        "dual-fix-no-dual-substitution-for-lp"
        "dual-fix-dual-substitution"
        "dual-fix-dual-substitution-rounding"
        "dual-fix-dual-substitution-unbounded-variables"
        "dual-fix-dual-substitution-equation"
        "dual-fix-infinity"

        # Fix Continuous
        "happy-path-presolve-fix-continuous"
        "happy-path-no-presolve-fix-continuous"

        #FreeVarSubstitution
        "happy-path-test-free-variable-detection"

        #Implied Integer
        "happy-path-implied-integer-detection"

        #Parallel Row Detection
        "parallel-row-unchanged"
        "parallel-row-two-equations-infeasible-second-row-dominant"
        "parallel-row-two-equations-infeasible-first-row-dominant"
        "parallel-row-two-equations-feasible-second-row-dominant"
        "parallel-row-two-equations-feasible-first-row-dominant"
        "parallel-row-two-inequalities-redundant-row-second-row-dominant"
        "parallel-row-two-inequalities-redundant-row-first-row-dominant"
        "parallel-row-two-inequalities-tighten-lower-bound-second-row-dominant"
        "parallel-row-two-inequalities-tighten-lower-bound-first-row-dominant"
        "parallel-row-two-inequalities-tighten-upper-bound-second-row-dominant"
        "parallel-row-two-inequalities-tighten-upper-bound-first-row-dominant"
        "parallel-row-two-inequalities-infeasible-first-row-dominant"
        "parallel-row-two-inequalities-infeasible-second-row-dominant"
        "parallel-row-two-inequalities-tighten-upper-bound-first-row-negfactor-dominant"
        "parallel-row-overwrite-inf-first-row-rhs-inf"
        "parallel-row-overwrite-inf-first-row-lhs-inf"
        "parallel-row-overwrite-inf-first-row-lhs-inf-neg-factor"
        "parallel-row-mixed-infeasible-first-row-equation"
        "parallel-row-best-bound-is-used-for-rhs-coeff-not-1"
        "parallel-row-best-bound-is-used-for-rhs-coeff"
        "parallel-row-mixed-second-row-equation"
        "parallel-row-mixed-infeasible-second-row-equation"
        "parallel-row-multiple-parallel-rows"
        "parallel-row-two-identical-equations"

        #parallel Column Detection
        "parallel_col_detection_2_integer_columns"
        "parallel_col_detection_2_continuous_columns"
        "parallel_col_detection_int_cont_merge_possible"
        "parallel_col_detection_cont_int_merge_possible"
        "parallel_col_detection_cont_int_merge_failed"
        "parallel_col_detection_int_cont_merge_failed"
        "parallel_col_detection_int_merge_failed_hole"
        "parallel_col_detection_obj_not_parallel"
        "parallel_col_detection_multiple_parallel_columns"
        "parallel_col_detection_objective_zero"

        #Probing
        "happy-path-probing"
        "failed-path-probing-on-not-binary-variables"

        #Singleton Column
        "happy-path-singleton-column"
        "happy-path-singleton-column-equation"
        "happy-path-singleton-column-implied-bounds-negative-coeff-pos-bounds"
        "happy-path-singleton-column-implied-bounds-negative-coeff-neg-bounds"
        "happy-path-singleton-column-implied-bounds-positive-coeff-pos-bounds"
        "happy-path-singleton-column-implied-bounds-positive-coeff-neg-bounds"

        #Singleton Stuffing
        "singleton-stuffing-make-sure-to-first-set-bounds-to-infinity"

        #Simple Probing
        "simple-probing-trivial-example"
        "simple-probing-negative-binary-coeff"
        "simple-probing-positive-binary-coeff"
        "simple-different-int-coeff"
        "simple-different-int-coeff-pt2"

        #Simple Substitution
        "simple-substitution-happy-path-for-2-int"
        "simple-substitution-happy-path-for-2-continuous"
        "simple-substitution-happy-path-for-continuous-and-integer"
        "simple-substitution-happy-path-for-int-continuous-coeff"
        "simple-substitution-should_return_feasible_if_gcd_of_coeff_is_in_rhs"
        "simple-substitution-should_return_infeasible_if_gcd_of_coeff_is_in_rhs"
        "simple-substitution-simple-substitution-for-2-int"
        "simple-substitution-2-negative-integer"
        "simple-substitution-feasible-gcd"
        "simple-substitution-non-coprime"
        "simple-substitution-violated-gcd"

        #Simplify Inequality
        "happy-path-simplify-inequalities"
        "simplify_inequ_doesnt_lock_more_rows"
        "simplify_inequ_doesnt_apply_lb_and_ub_on_one_row"

        #Sparsify
        "happy-path-sparsify"
        "happy-path-sparsify-two-equalities"
        "failed-path-sparsify-if-misses-one-for-integer"

        ${PAPILOLIB_TESTS}
        ${BOOST_REQUIRED_TESTS}
        )

# add a test to build the SCIP binary that all further tests depend on
add_test(NAME unit-test-build
        COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target unit_test
        )

set_tests_properties(unit-test-build
        PROPERTIES
        RESOURCE_LOCK unittestbin)

foreach (test ${unit_tests})
    add_test(NAME unit-test-${test} COMMAND unit_test ${test})

    set_tests_properties(unit-test-${test}
            PROPERTIES
            DEPENDS unit-test-build)
endforeach ()

if (TARGET papilo-executable)

    # MIP instances
    set(instances_MIP
            "MIP/bell5.mps\;8966406.49152"
            "MIP/blend2.mps\;7.598985"
            "MIP/dcmulti.mps\;188182"
            "MIP/egout.mps\;568.1007"
            "MIP/enigma.mps\;0"
            "MIP/flugpl.mps\;1201500"
            "MIP/gt2.mps\;21166"
            "MIP/lseu.mps\;1120"
            "MIP/misc03.mps\;3360"
            "MIP/p0548.mps\;8691"
            "MIP/rgn.mps\;82.19999924"
            )

    set(instances_gurobi_MIP
            "MIP/bell5.mps\;8966406.49152"
            "MIP/blend2.mps\;7.598985"
            #"MIP/dcmulti.mps\;188182" gurobi per default does not close the gap entirely
            "MIP/egout.mps\;568.1007"
            "MIP/enigma.mps\;0"
            "MIP/flugpl.mps\;1201500"
            "MIP/gt2.mps\;21166"
            "MIP/lseu.mps\;1120"
            "MIP/misc03.mps\;3360"
            "MIP/p0548.mps\;8691"
            "MIP/rgn.mps\;82.19999924"
            )


    # LP instances
    set(instances_LP
            "LP/adlittle.mps\;0.22549496316238038228101176621492e6"
            "LP/afiro.mps\;-0.46475314285714285714285714285714e3"
            "LP/agg.mps\;-0.35991767286576506712640824319636e8"
            "LP/beaconfd.mps\;0.335924858072e5"
            #TODO: MPS error while RHS identifier is missing
            #"LP/blend.mps\;-0.30812149845828220173774356124984e2"
            "LP/bore3d.mps\;0.13730803942084927215581987251301e4"
            "LP/brandy.mps\;0.15185098964881283835426751550618e4"
            "LP/capri.mps\;0.26900129137681610087717280693754e4"
            #TODO: objective value differs slightly
            #"LP/etamacro.mps\;-0.7557152333749133350792583667773e3"
            "LP/finnis.mps\;0.17279106559561159432297900375543e6"
            "LP/israel.mps\;-0.89664482186304572966200464196045e6"
            "LP/kb2.mps\;-0.17499001299062057129526866493726e4"
            "LP/lotfi.mps\;-0.2526470606188e2"
            "LP/recipe.mps\;-0.266616e3"
            "LP/sc105.mps\;-0.52202061211707248062628010857689e2"
            "LP/sc205.mps\;-0.52202061211707248062628010857689e2"
            "LP/sc50a.mps\;-0.64575077058564509026860413914575e2"
            "LP/sc50b.mps\;-0.7e2"
            "LP/scagr7.mps\;-0.2331389824330984e7"
            "LP/scagr25.mps\;-0.14753433060768523167790925075974e8"
            "LP/scfxm1.mps\;0.18416759028348943683579089143655e5"
            "LP/scorpion.mps\;0.18781248227381066296479411763586e4"
            "LP/scrs8.mps\;0.90429695380079143579923107948844e3"
            "LP/scsd1.mps\;0.86666666743333647292533502995263e1"
            "LP/seba.mps\;0.157116e5"
            "LP/share1b.mps\;-0.7658931857918568112797274346007e5"
            "LP/share2b.mps\;-0.41573224074141948654519910873841e3"
            "LP/shell.mps\;0.1208825346e10"
            "LP/vtp-base.mps\;0.1298314624613613657395984384889e6"
            )

    set(infeas_LP
            "LP/bgetam.mps"
            "LP/box1.mps"
            "LP/galenet.mps"
            "LP/gams10am.mps"
            "LP/refinery.mps"
            "LP/woodinfe.mps"
            "LP/klein1.mps"
            "LP/ex72a.mps"
            "LP/forest6.mps"
            )

    set(numtypes
            "d"
            "q"
            "r"
            )
    set(double_numtypes
            "d"
            )

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILD_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_TESTING=$(BUILD_TESTING) \
		-DBUILD_SHARED_LIBS=ON \
		-DPAPILO_CLUSOL_SOVERSION=0d \
		-DPAPILO_CORE_SOVERSION=0d

override_dh_auto_test:
	-dh_auto_test --buildsystem=cmake

execute_before_dh_installman:
	sed -e 's/@VERSION@/$(DEB_VERSION_UPSTREAM)/g' debian/papilo.1.in > debian/papilo.1

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,uversionmangle=s%[.-]?(a|b|c|rc|dev|pre)%~$1%;s%^\d\d\d.*%~0.ignore%,dversionmangle=auto,oversionmangle=s%$%+ds%,repack \
 https://api.github.com/repos/scipopt/papilo/tags \
 tarball/(?:[^"]*?/)?[a-z]*@ANY_VERSION@

## papilo 2.4.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 set(PAPILO_VERSION_MAJOR 2)
 set(PAPILO_VERSION_MINOR 4)
-set(PAPILO_VERSION_PATCH 1)
+set(PAPILO_VERSION_PATCH 3)
 set(PAPILO_API_VERSION 3)
 
 project(papilo VERSION ${PAPILO_VERSION_MAJOR}.${PAPILO_VERSION_MINOR}.${PAPILO_VERSION_PATCH}.0)
@@ -344,14 +344,14 @@
 # TODO: Simplify with a generator expression.
 function(setLibProperties targetname outputname)
     set_target_properties(${targetname} PROPERTIES
-        OUTPUT_NAME ${outputname}
-        MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+        OUTPUT_NAME ${outputname})
 endfunction(setLibProperties)
 if(MSVC)
     setLibProperties(papilo-core "libpapilo-core")
 else()
-   setLibProperties(papilo-core "papilo-core")
+    setLibProperties(papilo-core "papilo-core")
 endif()
 
 
 # Add dependency-target `papilo` to static library-target `papilo-core`.
+target_link_libraries(papilo-core papilo)

=== binaries/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 include(GenerateExportHeader)
 
 if(SCIP)
-   find_package(SCIP)
+   find_package(SCIP CONFIG HINTS ${SCIP_DIR})
 endif()
 if(SCIP_FOUND)
    message(STATUS "Found SCIP: ${SCIP_INCLUDE_DIRS}")
@@ -40,7 +40,7 @@
 
 
 if(SOPLEX)
-   find_package(SOPLEX)
+   find_package(SOPLEX CONFIG HINTS ${SOPLEX_DIR})
 endif()
 if(SOPLEX_FOUND)
    message(STATUS "Found SOPLEX: ${SOPLEX_INCLUDE_DIRS}")
@@ -51,7 +51,7 @@
 endif()
 
 if(HIGHS)
-   find_package(HIGHS CONFIG REQUIRED)
+   find_package(HIGHS CONFIG REQUIRED HINTS ${HIGHS_DIR})
 endif()
 if(HIGHS_FOUND)
    message(STATUS "Found HIGHS: ${HIGHS_INCLUDE_DIRS}")

=== debian/changelog ===
papilo (2.4.3+ds-1) unstable; urgency=medium

  * New upstream version 2.4.3+ds
  * Refresh patches (no functional changes)
  * Fix Multi-Arch conflict on CMakeConfig.hpp
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Wed, 20 Aug 2025 10:38:44 +0200

## papilo 2.4.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 set(PAPILO_VERSION_MAJOR 2)
 set(PAPILO_VERSION_MINOR 4)
-set(PAPILO_VERSION_PATCH 3)
+set(PAPILO_VERSION_PATCH 4)
 set(PAPILO_API_VERSION 3)
 
 project(papilo VERSION ${PAPILO_VERSION_MAJOR}.${PAPILO_VERSION_MINOR}.${PAPILO_VERSION_PATCH}.0)

=== Makefile ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*                  This file is part of the program and library             *
#*         SCIP --- Solving Constraint Integer Programs                      *
#*                                                                           *
#*    Copyright (C) 2002-2025 Zuse Institute Berlin (ZIB)                    *
#*                                                                           *
#*  SCIP is distributed under the terms of the ZIB Academic License.         *
#*                                                                           *
#*  You should have received a copy of the ZIB Academic License              *
#*  along with SCIP; see the file COPYING. If not email to scip@zib.de.      *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

# description -> see check/README_PERFORMANCE.md

#-----------------------------------------------------------------------------
# paths variables
#-----------------------------------------------------------------------------

PAPILODIR=$(shell pwd -P)

.DEFAULT_GOAL := help

#-----------------------------------------------------------------------------
# include make.project file
#-----------------------------------------------------------------------------

# load default settings and detect host architecture
include $(PAPILODIR)/make/make.project

# include local targets
-include make/local/make.targets

#-----------------------------------------------------------------------------
# Rules
#-----------------------------------------------------------------------------

.PHONY: help
help:
		@echo "  Main targets:"
		@echo "  - test: start Papilo testrun locally."
		@echo "  - testcluster: start Papilo testrun on the cluster."

.PHONY: test
test:
		cd check; \
		$(SHELL) ./check.sh $(TEST) $(EXECUTABLE) $(SETTINGS) $(BINID) $(OUTPUTDIR) $(TIME) $(NODES) $(MEM) $(FEASTOL) $(DISPFREQ) \
		$(CONTINUE) $(LOCK) $(VERSION) $(LPS) $(DEBUGTOOL) $(CLIENTTMPDIR) $(REOPT) $(PAPILO_OPT_COMMAND) $(SETCUTOFF) $(MAXJOBS) $(VISUALIZE) $(PERMUTE) \
                $(SEEDS) $(GLBSEEDSHIFT) $(STARTPERM) $(SOLVE_EXECUTABLE) $(SKIP_PRESOLVE);

# --- EOF ---------------------------------------------------------------------
# DO NOT DELETE

=== binaries/CMakeLists.txt ===
--- 
+++ 
@@ -161,7 +161,6 @@
    if(PAPILO_HAVE_HIGHS)
       list(APPEND linked_solvers "HiGHS")
       set(PAPILO_HAVE_HIGHS 1 PARENT_SCOPE)
-      find_package(OpenMP)
       target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_HIGHS)
       target_link_libraries(papilo-executable highs::highs)
    endif()

=== check/parser/requirements.txt ===
dataclasses
numpy

=== debian/changelog ===
papilo (2.4.4+ds-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 2.4.4+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Mon, 27 Oct 2025 22:35:58 +0100

=== debian/control ===
Source: papilo
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 catch2 <!nocheck>,
 cmake,
 gfortran,
 libblas-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libfmt-dev,
 libsoplex-dev,
 libtbb-dev (>= 2020),
Homepage: https://github.com/scipopt/papilo
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/math-team/papilo.git
Vcs-Browser: https://salsa.debian.org/math-team/papilo
Description: Parallel Presolve for Integer and Linear Optimization
 PaPILO, a C++14-based software package, provides parallel presolve routines
 for (mixed integer) linear programming problems. The routines are implemented
 using templates which allows switching to higher precision or rational
 arithmetic using the boost multiprecision package.

Package: papilo
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package installs an executable for presolving and postsolving MILP
 instances based on files. The executable can also act as frontend for the
 SoPlex solver.

Package: libpapilo-clusol0d
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (LUSOL library)
 ${source:Extended-Description}
 .
 This package installs the shared PaPILO LUSOL library.

Package: libpapilo-core0d
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (core library)
 ${source:Extended-Description}
 .
 This package installs the shared PaPILO core library.

Package: libpapilo-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libboost-dev (>= 1.65),
 libpapilo-clusol0d (= ${binary:Version}),
 libpapilo-core0d (= ${binary:Version}),
 libtbb-dev (>= 2020),
 ${misc:Depends},
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides the necessary files to develop and link against the
 PaPILO library.

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 BUILD_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
+
+include /usr/share/dpkg/architecture.mk
 
 %:
 	dh $@ --buildsystem=cmake
@@ -20,3 +22,8 @@
 execute_before_dh_installman:
 	sed -e 's/@VERSION@/$(DEB_VERSION_UPSTREAM)/g' debian/papilo.1.in > debian/papilo.1
 
+execute_after_dh_auto_install:
+	# Fix Multi-Arch conflict due to architecture-specific settings in auto-generated config file
+	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/papilo
+	mv debian/tmp/usr/include/papilo/CMakeConfig.hpp debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/papilo
+

=== debian/watch ===
Version: 5

Template: Github
Owner: scipopt
Project: papilo
Uversion-Mangle: auto
Dversion-Mangle: auto
Repack-Suffix: +ds
Repack: yes
